/* ========
 * libqpace
 * ========
 * $Id: qpace.h 2931 2009-12-22 17:41:37Z pleiter $
 * -------------------------------------------------------------------------- */

#ifndef QPACE_H
#define QPACE_H

#include <unistd.h>
#include <inttypes.h>
#include <pthread.h>
#include <libspe2.h>

#include "qpace_mem.h"
#include "qpace_dcr.h"

void _qpace_die(const char*, const char*, ...);

void qpace_devmem_open();
void qpace_devmem_close();

void *qpace_mmap(int, off64_t, size_t);

void *qpace_mmap_iwc();
void *qpace_mmap_dcr();
void *qpace_mmap_dcrtnw();

int qpace_torus_init(unsigned char **, unsigned char **);
void qpace_torus_finish();

int qpace_get_spu_phys_id(spe_context_ptr_t);

#define qpace_die(ARGS...) _qpace_die(__func__, ##ARGS)

#endif

